#!/usr/bin/perl

#
# PONNY CHAT : init.cgi - 2011/09/12
# Copyright (c) KentWeb
# http://www.kent-web.com/
#
# REBUILD()
#
#  PONNY CHAT v4.0 PLUS member & deny & admin 2016/12/05
#  Edited by Hamel(TRANSFORM) Since 2012
#  http://www.transformsite.com/
#

# W[錾
use strict;
use CGI::Carp qw(fatalsToBrowser);

# ݒt@CF
require "./init.cgi";
my %cf = set_init();

# f[^
my %in = parse_form();

# 
deny_host();
if ($in{mode} eq "form") { form(); }
if ($in{mode} eq "into") { form2(); }
if ($in{comment} && $in{mode} eq "regist") { regist(); }
if ($in{mode} eq "out") { room_out(); }
if ($in{mode} eq 'rank') { rank_list(); }
chat_data();

#-----------------------------------------------------------
#  tH[ : O
#-----------------------------------------------------------
sub form {
	my ($op_retime,$op_colors);
	foreach (@{$cf{retime}}) {
		if ($cf{retime_defo} == $_) {
			$op_retime .= qq|<option value="$_" selected>$_b\n|;
		} else {
			$op_retime .= qq|<option value="$_">$_b\n|;
		}
	}
	foreach (0 .. $#{$cf{colors}}) {
		my ($fnam,$nam) = split(/,/, $cf{colors}->[$_]);
		$op_colors .= qq|<option value="$_" style="color:$fnam">$nam\n|;
	}

	open(IN,"$cf{tmpldir}/form.html") or &error("open err: form.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!chat_title!/$cf{chat_title}/g;
	$tmpl =~ s/!chat_cgi!/$cf{chat_cgi}/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/ponny.css|g;
	$tmpl =~ s/!admin_cgi!/$cf{admin_cgi}/g;
	$tmpl =~ s/<!-- op_retime -->/$op_retime/g;
	$tmpl =~ s/<!-- op_colors -->/$op_colors/g;
	$tmpl =~ s/<!-- ranking_begin -->.+<!-- ranking_end -->//s if ($cf{ranking});

	print "Content-type: text/html\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  tH[ : 
#-----------------------------------------------------------
sub form2 {
	$in{name} ||= $ENV{REMOTE_ADDR};

	# ē
	regist('into');

	my ($op_retime,$op_colors);
	foreach (@{$cf{retime}}) {
		if ($in{retime} == $_) {
			$op_retime .= qq|<option value="$_" selected>$_b\n|;
		} else {
			$op_retime .= qq|<option value="$_">$_b\n|;
		}
	}
	foreach (0 .. $#{$cf{colors}}) {
		my ($fnam,$nam) = split(/,/, $cf{colors}->[$_]);
		if ($in{color} == $_) {
			$op_colors .= qq|<option value="$_" style="color:$fnam"selected>$nam\n|;
		} else {
			$op_colors .= qq|<option value="$_" style="color:$fnam">$nam\n|;
		}
	}

	# OGR[h
	my $enam = url_encode($in{name});

	open(IN,"$cf{tmpldir}/form2.html") or &error("open err: form2.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!chat_cgi!/$cf{chat_cgi}/g;
	$tmpl =~ s/!chat_title!/$cf{chat_title}/g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/ponny.css|g;
	$tmpl =~ s/<!-- op_retime -->/$op_retime/g;
	$tmpl =~ s/<!-- op_colors -->/$op_colors/g;
	$tmpl =~ s/!name!/$in{name}/g;
	$tmpl =~ s/!enam!/$enam/g;
	$tmpl =~ s/<!-- ranking_begin -->.+<!-- ranking_end -->//s if ($cf{ranking});

	print "Content-type: text/html\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  L\
#-----------------------------------------------------------
sub chat_data {
	if ($in{retime} eq '') { $in{retime} = $cf{retime_defo}; }
	my ($retime,$meta);
	if ($in{retime} == 0) {
		$retime = '蓮';
	} else {
		$retime = "$in{retime}b";
		$meta = qq|<meta http-equiv="refresh" content="$in{retime}; url=$cf{chat_cgi}?retime=$in{retime}">|;
	}

	# ݎ
	my ($num,$member) = member();

	open(IN,"$cf{tmpldir}/data.html") or &error("open err: data.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!retime!/$retime/g;
	$tmpl =~ s/<!-- meta_refresh -->/$meta/;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/ponny.css|g;
	$tmpl =~ s/!member!/$member/g;
	$tmpl =~ s/!num!/$num/g;

	# ev[g
	my ($head,$loop1,$loop2,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- boundary -->(.+)<!-- loop_end -->(.+)/s
		? ($1,$2,$3,$4) : error("ev[gs");

	print "Content-type: text/html\n\n";
	print $head;

	my $i;
	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	while (<IN>) {
		my ($date,$name,$com,$col,undef,undef) = split(/<>/);

		$i++;
		my $tmp = $i % 2 ? $loop1 : $loop2;
		$tmp =~ s|!name!|<span style="color:$col">$name</span>|g;
		$tmp =~ s|!comment!|<span style="color:$col">$com</span>|g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!color!/$col/g;
		print $tmp;
	}
	close(IN);

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  
#-----------------------------------------------------------
sub regist {
	my $job = shift;

	# 擾
	my ($sec,$min,$hour,$mday,$mon) = (localtime(time))[0..4];
	my $date = sprintf("%02d/%02d-%02d:%02d:%02d",$mon+1,$mday,$hour,$min,$sec);
	my $time = get_time();

	# zXg
	my $host = get_host();

	# O`Ԃ𔻒f
	my ($name,$color);
	if ($job eq 'into') {
		$in{comment} = "<b>$in{name}</b>$cf{msg_in}";
		$name = $cf{master_name};
		$color = $cf{rep_color};
	} elsif ($job eq 'out') {
		$in{comment} = "<b>$in{enam}</b>$cf{msg_out}";
		$name = $cf{master_name};
		$color = $cf{rep_color};
	} else {
		$name = $in{name};
		($color,undef) = split(/,/, $cf{colors}->[$in{color}]);

		# LO
		if ($cf{rankkey}) { ranking(); }

	}

	my ($i,@log);
	open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		$i++;
		push(@log,$_);
		last if ($i >= $cf{maxlog}-1);
	}

	## clear Ɠ͂邱ƂŎ̋L폜
	if ($in{comment} eq 'clear'){
		my @temp;
		my $match;
		foreach (@log) {
			my ($hos) = (split(/<>/))[4];
			if ($host eq $hos) { $match = 1; }
			else { push(@temp,$_); }
		}
		if ($match) {
			@log = @temp;
			$in{comment} = "All Clear (^-^)v";
		}
	}

	unshift (@log,"$date<>$name<>$in{comment}<>$color<>$host<>$time\n");
	seek(DAT, 0, 0);
	print DAT @log;
	truncate(DAT, tell(DAT));
	close(DAT);
}

#-----------------------------------------------------------
#  N
#-----------------------------------------------------------
sub ranking {
	my $now = time;

	my ($flg,@log);
	open(DAT,"+< $cf{rankfile}") || &error("open err: $cf{rankfile}");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		my ($name,$kaisu,$time) = split(/<>/);
		next if ($now - $time > $cf{limit}*24*60*60);

		if ($name eq $in{name}) {
			$flg++;
			$kaisu++;
			$_ = "$name<>$kaisu<>$now<>\n";
		}
		push(@log,$_);
	}
	if (!$flg) { unshift(@log,"$in{name}<>1<>$now<>\n"); }
	seek(DAT, 0, 0);
	print DAT @log;
	truncate(DAT, tell(DAT));
	close(DAT);
}

#-----------------------------------------------------------
#  LO
#-----------------------------------------------------------
sub rank_list {
	# Nt@Cǂݍ
	my (@sort,@data);
	open(IN,"$cf{rankfile}") || &error("open err: $cf{rankfile}");
	while(<IN>) {
		my ($name,$count) = split(/<>/);

		push(@sort,$count);
		push(@data,$_);
	}
	close(IN);

	# \[g
	@data = @data[sort {$sort[$b] <=> $sort[$a]} 0 .. $#sort];

	open(IN,"$cf{tmpldir}/rank.html") or &error("open err: rank.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!limit!/$cf{limit}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/ponny.css|g;
	$tmpl =~ s/!chat_title!/$cf{chat_title}/g;

	# ev[g
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1,$2,$3);
	} else {
		&error("ev[gsł");
	}

	# ʕ\
	print "Content-type: text/html\n\n";
	print $head;

	my ($i,$b_c,$b_r);
	foreach (@data) {
		$i++;
		my ($name,$count) = split(/<>/);
		my $rank = $count == $b_c ? $b_r : $i;

		my $tmp = $loop;
		$tmp =~ s/!rank!/$rank/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!count!/$count/g;
		print $tmp;

		$b_r = $rank;
		$b_c = $count;
	}

	print $foot;
	exit;
}

#-----------------------------------------------------------
#  tH[fR[h
#-----------------------------------------------------------
sub parse_form {
	my ($buf,%in);
	if ($ENV{REQUEST_METHOD} eq "POST") {
		&error('󗝂ł܂') if ($ENV{CONTENT_LENGTH} > $cf{maxdata});
		read(STDIN, $buf, $ENV{CONTENT_LENGTH});
	} else {
		$buf = $ENV{QUERY_STRING};
	}
	foreach ( split(/&/, $buf) ) {
		my ($key,$val) = split(/=/);
		$val =~ tr/+/ /;
		$val =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2", $1)/eg;

		# svR[h
		$val =~ s/&/&amp;/g;
		$val =~ s/</&lt;/g;
		$val =~ s/>/&gt;/g;
		$val =~ s/"/&quot;/g;
		$val =~ s/'/&#39;/g;
		$val =~ s/[\r\n]//g;

		$in{$key} = $val;
	}
	return %in;
}

#-----------------------------------------------------------
#  ݎǗ
#-----------------------------------------------------------
sub member {
	my $job = shift;

	# /IP擾
	my $now = time;
	my $addr = $ENV{REMOTE_ADDR};

	my ($i,$member,$flg,@log);
	open(DAT,"+< $cf{memfile}") or &error("open err: $cf{memfile}");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		my ($time,$name,$ip) = split(/<>/);

		# 60bȏ㔭̂Ȃ҂͍폜
		if ($now - 60 > $time) {
			$flg = 1;
			next;
		}

		if ($addr eq $ip) {
			$flg = 2;

			# ގҍ폜
			if ($job eq 'out') {
				next;

			# /OXV
			} else {
				$name = $in{name};
				$_ = "$now<>$name<>$addr<>\n";
			}
		}

		# XVpzɒǉ
		push(@log,$_);

		# Qҕ\p쐬
		if ($i % 2) {
			$member .= "$name";
			$i++;
		} else {
			$member .= "$name";
			$i++;
		}
	}

	# VKQҒǉ
	if (!$flg && $job ne 'out' && $in{name} ne '') {
		$flg = 3;
		push(@log,"$now<>$in{name}<>$addr<>\n");
		$member = $i % 2 ? "$member$in{name}" : "$member$in{name}";
	}

	# QҐ
	my $num = @log;

	# t@CXV
	if ($job || $flg) {
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
	}
	close(DAT);

	return ($num,$member);
}

#-----------------------------------------------------------
#  IPANZX
#-----------------------------------------------------------
sub deny_host {
	my $addr = $ENV{REMOTE_ADDR};
	my $flg;
	open(IN,"$cf{denyfile}") || &error("open err: $cf{denyfile}");
	while (<IN>) {
		chomp;
		next if (!$_);
		s/\*/\.\*/g;
		if ($addr =~ /$_/i) { $flg++; last; }
	}
	close(IN);

	error('\󂠂܂񂪌݂pł܂') if ($flg);
}

#-----------------------------------------------------------
#  ގ
#-----------------------------------------------------------
sub room_out {
	# ގē
	regist('out');
	member('out');

	open(IN,"$cf{tmpldir}/out.html") or &error("open err: out.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!name!/$in{enam}/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s/!chat_title!/$cf{chat_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/ponny.css|g;

	print "Content-type: text/html\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  tb^[
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 쌠\Li폜Eϋ֎~j
	my $copy = <<EOM;
<p style="margin-top:2em;text-align:center;font-family:verdana,helvetica,arial;font-size:11pt;">
- <a href="http://www.kent-web.com/" target="_top">$cf{version}</a> -<br />
- <a href="http://www.transformsite.com/" target="_top">Edited by Hamel</a> -
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  Ԏ擾
#-----------------------------------------------------------
sub get_time {
	$ENV{TZ} = "JST-9";
	my $time = time;
	my ($min,$hour,$mday,$mon,$year,$wday) = (localtime($time))[1..6];
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# ̃tH[}bg
	my $date = sprintf("%04d/%02d/%02d(%s) %02d:%02d",
			$year+1900,$mon+1,$mday,$week[$wday],$hour,$min);

	return ($date, $time);
}

#-----------------------------------------------------------
#  zXg擾
#-----------------------------------------------------------
sub get_host {
	# IP/zXg擾
	my $host = $ENV{REMOTE_HOST};
	my $addr = $ENV{REMOTE_ADDR};

	if ($cf{gethostbyaddr} && ($host eq "" || $host eq $addr)) {
		$host = gethostbyaddr(pack("C4", split(/\./, $addr)), 2);
	}
	$host ||= $addr;
	return $host;
}

#-----------------------------------------------------------
#  G[
#-----------------------------------------------------------
sub error {
	my $err = shift;

	open(IN,"$cf{tmpldir}/error.html") or die;
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!error!/$err/g;
	$tmpl =~ s/!chat_title!/$cf{chat_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/ponny.css|g;

	print "Content-type: text/html\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  URLGR[h
#-----------------------------------------------------------
sub url_encode {
	my $str = shift;

	$str =~ s/([^\w ])/'%'.unpack('H2', $1)/eg;
	$str =~ tr/ /+/;
	return $str;
}


